package net.aetherial.gis.garmin;

import java.io.*;
import java.util.*;

public class ConsoleConfig 
{
	public static String cfgFile = "Garmin.ini";
	private String serialPort;
	private String server;
	private String serverPort;

	public ConsoleConfig ()
	{
		try
		{
			BufferedReader in = new BufferedReader (new InputStreamReader (new FileInputStream (cfgFile)));
			String line = new String ("");

			int i = 0;
			for (line = in.readLine (); line != null; line = in.readLine (), i++)
			{
				if (! (line.startsWith ("#")))
				{
					StringTokenizer st = new StringTokenizer (line, "=");
					String name = st.nextToken ().trim ();
					String value = st.nextToken ().trim ();

					if (name.equals ("Serial Port"))
					{
						serialPort = value;
					}
					else if (name.equals ("Server"))
					{
						server = value;
					}
					else if (name.equals ("Server Port"))
					{
						serverPort = value;
					}
					else
					{
						System.err.println ("Error in configuration file "+cfgFile+", line "+i+": "+line);
					}
				}
			}

			in.close ();
		}
		catch (FileNotFoundException e)
		{
			serialPort = getDefaultSerialPort ();
			server = getDefaultServer ();
			serverPort = getDefaultServerPort ();

			commit ();
		}
		catch (IOException e)
		{
			System.err.println ("Error reading "+cfgFile+".");
		}
	}

	public void commit ()
	{
		try 
		{
			PrintWriter out = new PrintWriter (new FileOutputStream (cfgFile, false));

			out.println ("#");
			out.println ("# This file was automatically generated by the Console application.");
			out.println ("#");
			out.println ("Serial Port = "+serialPort);
			out.println ("Server = "+server);
			out.println ("Server Port = "+serverPort);

			out.close ();
		}
		catch (FileNotFoundException e)
		{
			System.err.println ("Unable to create "+cfgFile+".");
		}
	}

	public String getSerialPort ()
	{	
		return serialPort;
	}

	public String getServer ()
	{
		return server;
	}

	public String getServerPort ()
	{
		return serverPort;
	}

	public String getDefaultServer ()
	{
		return new String ("localhost");
	}

	public String getDefaultServerPort ()
	{
		return new String ("9999");
	}

	public String getDefaultSerialPort ()
	{
		return new String ("COM1");
	}

	public void setSerialPort (String sp)
	{
		serialPort = sp;
	}

	public void setServerName (String sn)
	{	
		server = sn;
	}

	public void setServerPort (String sp)
	{
		serverPort = sp;
	}
}
