package net.aetherial.gis.garmin;

import java.io.*;
import java.util.*;
import org.w3c.dom.*;
import net.aetherial.gis.garmin.*;

public class TrackLogCommand
{

	public static void getTrackLog ()
	{
		LinkPacketConnection lpc;
		LinkPacket packet;
		TrackHeader310 th;
		TrackPoint301 tp;

		Command cmd = new Command (Command.CMND_TRANSFER_TRK);
		cmd.execute ();

		lpc = cmd.getLinkPacketConnection ();

		packet = lpc.receive ();
		while (packet.getPacketType () != Garmin.XFER_COMPLETE)
		{
			if (packet.getPacketType () == Garmin.TRK_HDR)
			{
				th = new TrackHeader310 (packet.getPacketData ());
				th.printDetails ();
			}
			else if (packet.getPacketType () == Garmin.TRK_DATA)
			{
				tp = new TrackPoint301 (packet.getPacketData ());
				tp.printDetails ();
			}

			packet = lpc.receive ();
		}
	}

	public static void getTrackLogGML ()
	{
		LinkPacketConnection lpc;
		LinkPacket packet;
		TrackHeader310 th;
		TrackPoint301 tp;
		Element e = null;

		Command cmd = new Command (Command.CMND_TRANSFER_TRK);
		cmd.execute ();

		lpc = cmd.getLinkPacketConnection ();

		packet = lpc.receive ();
		packet = lpc.receive ();

		if (packet.getPacketType () == Garmin.TRK_HDR)
		{
			th = new TrackHeader310 (packet.getPacketData ());
			e = GarminGMLDoc.addTrack (th.getIdentifier ());
		}

		packet = lpc.receive ();

		while (packet.getPacketType () != Garmin.XFER_COMPLETE && e != null)
		{
			if (packet.getPacketType () == Garmin.TRK_DATA)
			{
				tp = new TrackPoint301 (packet.getPacketData ());
				GarminGMLDoc.addTrackPoint (e, tp);
			}
			else if (packet.getPacketType () == Garmin.TRK_HDR)
			{
				th = new TrackHeader310 (packet.getPacketData ());
				e = GarminGMLDoc.addTrack (th.getIdentifier ());
			}
			else
			{
				System.out.println ("error - packet ID: "+packet.getPacketType ());
			}

			packet = lpc.receive ();
		}

		lpc.destroy ();
	}
}
